// Server reads then writes

package jss;

import java.io.InputStream;
import java.io.OutputStream;

import org.mozilla.jss.CryptoManager;
import org.mozilla.jss.crypto.X509Certificate;
import org.mozilla.jss.ssl.SSLServerSocket;
import org.mozilla.jss.ssl.SSLSocket;
import org.mozilla.jss.util.Password;

public class SimpleJSSServer {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		SimpleJSSServer app = new SimpleJSSServer();
		app.run();
	}

	private void run() throws Exception {
		
		
		CryptoManager.InitializationValues initValues = new CryptoManager.InitializationValues("c:\\jssTest");
		initValues.fipsMode = CryptoManager.InitializationValues.FIPSMode.ENABLED;
		initValues.passwordCallback = new Password("change!tn0w".toCharArray());
		CryptoManager.initialize(initValues);
		
		CryptoManager cm = CryptoManager.getInstance();
		X509Certificate[] caCerts = cm.getCACerts();
		System.out.println("Retrieved caCerts: " + caCerts.length);
		for (int i = 0; i < caCerts.length; i++) {
			X509Certificate certificate = caCerts[i];
			System.out.println("Alg: " + certificate.getPublicKey().getAlgorithm());
			System.out.println("Name: " + certificate.getSubjectDN().getName());
		}
		
		SSLServerSocket listenSocket = new SSLServerSocket(443);
		listenSocket.setServerCertNickname("jssServerCert");
		listenSocket.requestClientAuth(true);
		
		SSLSocket socket = (SSLSocket) listenSocket.accept();

		InputStream is = socket.getInputStream();
		OutputStream os = socket.getOutputStream();
		
		byte[] input = new byte[100];
		int bytes = is.read(input);
		System.out.println("Read: " + new String(input, 0, bytes));
		os.write("Goodbye from server".getBytes());

		is.close();
		os.close();
		socket.close();
		listenSocket.close();
	}
}
